- Main Page
- Related Pages
- Modules
- Files

Functions
GLM_GTX_quaternion
GTX Extensions (Experimental)

## Functions
template<typename valType >
detail::tvec3< valType > | cross (detail::tquat< valType > const &q, detail::tvec3< valType > const &v)
template<typename valType >
detail::tvec3< valType > | cross (detail::tvec3< valType > const &v, detail::tquat< valType > const &q)
template<typename valType >
detail::tquat< valType > | exp (detail::tquat< valType > const &q, valType const &exponent)
template<typename valType >
valType | extractRealComponent (detail::tquat< valType > const &q)
template<typename T >
detail::tquat< T > | fastMix (detail::tquat< T > const &x, detail::tquat< T > const &y, T const &a)
template<typename valType >
detail::tquat< valType > | intermediate (detail::tquat< valType > const &prev, detail::tquat< valType > const &curr, detail::tquat< valType > const &next)
template<typename valType >
detail::tquat< valType > | log (detail::tquat< valType > const &q)
template<typename valType >
detail::tquat< valType > | pow (detail::tquat< valType > const &x, valType const &y)
template<typename valType >
detail::tvec3< valType > | rotate (detail::tquat< valType > const &q, detail::tvec3< valType > const &v)
template<typename valType >
detail::tvec4< valType > | rotate (detail::tquat< valType > const &q, detail::tvec4< valType > const &v)
template<typename T >
detail::tquat< T > | shortMix (detail::tquat< T > const &x, detail::tquat< T > const &y, T const &a)
template<typename valType >
detail::tquat< valType > | squad (detail::tquat< valType > const &q1, detail::tquat< valType > const &q2, detail::tquat< valType > const &s1, detail::tquat< valType > const &s2, valType const &h)
template<typename valType >
detail::tmat3x3< valType > | toMat3 (detail::tquat< valType > const &x)
template<typename valType >
detail::tmat4x4< valType > | toMat4 (detail::tquat< valType > const &x)
template<typename valType >
detail::tquat< valType > | toQuat (detail::tmat3x3< valType > const &x)
template<typename valType >
detail::tquat< valType > | toQuat (detail::tmat4x4< valType > const &x)

## Detailed Description

Extented quaternion types and functions.

<glm/gtx/quaternion.hpp> need to be included to use these functionalities.

## Function Documentation

detail::tvec3<valType> glm::cross | ( | detail::tquat< valType > const & | q,
|  | detail::tvec3< valType > const & | v
| ) |  |

Compute a cross product between a quaternion and a vector.

See Also
  GLM_GTX_quaternion

detail::tvec3<valType> glm::cross | ( | detail::tvec3< valType > const & | v,
|  | detail::tquat< valType > const & | q
| ) |  |

Compute a cross product between a vector and a quaternion.

See Also
  GLM_GTX_quaternion

detail::tquat<valType> glm::exp | ( | detail::tquat< valType > const & | q,
|  | valType const & | exponent
| ) |  |

Returns a exp of a quaternion.

See Also
  GLM_GTX_quaternion

valType glm::extractRealComponent | ( | detail::tquat< valType > const & | q | ) |

Extract the real component of a quaternion.

See Also
  GLM_GTX_quaternion

detail::tquat<T> glm::fastMix | ( | detail::tquat< T > const & | x,
|  | detail::tquat< T > const & | y,
|  | T const & | a
| ) |  |

Quaternion normalized linear interpolation.

See Also
  GLM_GTX_quaternion

detail::tquat<valType> glm::intermediate | ( | detail::tquat< valType > const & | prev,
|  | detail::tquat< valType > const & | curr,
|  | detail::tquat< valType > const & | next
| ) |  |

Returns an intermediate control point for squad interpolation.

See Also
  GLM_GTX_quaternion

detail::tquat<valType> glm::log | ( | detail::tquat< valType > const & | q | ) |

Returns a log of a quaternion.

See Also
  GLM_GTX_quaternion

detail::tquat<valType> glm::pow | ( | detail::tquat< valType > const & | x,
|  | valType const & | y
| ) |  |

Returns x raised to the y power.

See Also
  GLM_GTX_quaternion

detail::tvec3<valType> glm::rotate | ( | detail::tquat< valType > const & | q,
|  | detail::tvec3< valType > const & | v
| ) |  |

Returns quarternion square root.

See Also
  GLM_GTX_quaternion Rotates a 3 components vector by a quaternion.
  GLM_GTX_quaternion

detail::tvec4<valType> glm::rotate | ( | detail::tquat< valType > const & | q,
|  | detail::tvec4< valType > const & | v
| ) |  |

Rotates a 4 components vector by a quaternion.

See Also
  GLM_GTX_quaternion

detail::tquat<T> glm::shortMix | ( | detail::tquat< T > const & | x,
|  | detail::tquat< T > const & | y,
|  | T const & | a
| ) |  |

Quaternion interpolation using the rotation short path.

See Also
  GLM_GTX_quaternion

detail::tquat<valType> glm::squad | ( | detail::tquat< valType > const & | q1,
|  | detail::tquat< valType > const & | q2,
|  | detail::tquat< valType > const & | s1,
|  | detail::tquat< valType > const & | s2,
|  | valType const & | h
| ) |  |

Compute a point on a path according squad equation.

q1 and q2 are control points; s1 and s2 are intermediate control points.

See Also
  GLM_GTX_quaternion

detail::tmat3x3<valType> glm::toMat3 | ( | detail::tquat< valType > const & | x | ) |

Converts a quaternion to a 3 * 3 matrix.

See Also
  GLM_GTX_quaternion

Definition at line 149 of file gtx/quaternion.hpp.

References glm::mat3_cast().

detail::tmat4x4<valType> glm::toMat4 | ( | detail::tquat< valType > const & | x | ) |

Converts a quaternion to a 4 * 4 matrix.

See Also
  GLM_GTX_quaternion

Definition at line 156 of file gtx/quaternion.hpp.

References glm::mat4_cast().

detail::tquat<valType> glm::toQuat | ( | detail::tmat3x3< valType > const & | x | ) |

Converts a 3 * 3 matrix to a quaternion.

See Also
  GLM_GTX_quaternion

Definition at line 163 of file gtx/quaternion.hpp.

References glm::quat_cast().

detail::tquat<valType> glm::toQuat | ( | detail::tmat4x4< valType > const & | x | ) |

Converts a 4 * 4 matrix to a quaternion.

See Also
  GLM_GTX_quaternion

Definition at line 170 of file gtx/quaternion.hpp.

References glm::quat_cast().